# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/%{name}/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define reltag GA
%define	namedversion %{version}.%{reltag}

Name:		jms-integration-tests	
Version:	1.0.1
Release:	2%{?dist}
Epoch:          0
Summary:	JMS Integration Tests
Group:		Development/Libraries/Java
License:	LGPLv2+
URL:		http://anonsvn.jboss.org/repos/messaging/projects/jms-integration/
# svn export http://anonsvn.jboss.org/repos/messaging/projects/jms-integration/
# Exported revision 7920.
Source0:	jms-integration-tests-src.tar.gz	
Source1:	jms-integration-tests-libraries.ent
Source2:	%{name}-component-info.xml
# pom.xml files from: https://svn.jboss.org/repos/repository.jboss.org/maven2/jboss/jms-integration-tests/
Source3:	jms-integration-tests-1.0.1.GA.pom
Source4:	integration-mdb20-1.0.1.GA.pom
Source5:	integration-mdb20-durable-1.0.1.GA.pom
Source6:	integration-mdb20-selector-1.0.1.GA.pom
Source7:	integration-mdb20-userTransaction-1.0.1.GA.pom
Source8:	integration-mdb20-userTransactionDups-1.0.1.GA.pom
Patch0:		%{name}-build_xml.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:	ant
Requires:       jpackage-utils
BuildRequires:  jboss5-libs
BuildRequires:  jboss-naming
#
BuildRequires:	ant
BuildRequires:	ant-junit
BuildRequires:	concurrent
BuildRequires:	gnu-trove
BuildRequires:	javassist
BuildRequires:	jboss-aop2
BuildRequires:	jboss-common-core
BuildRequires:	jboss-common-logging-log4j
BuildRequires:	jboss-common-logging-spi
BuildRequires:	jboss-ejb-3.0-api
BuildRequires:	jboss-jms-1.1-api
BuildRequires:	jboss-messaging
BuildRequires:	jboss-microcontainer2
BuildRequires:	jboss-remoting
BuildRequires:	jboss-serialization
BuildRequires:	jboss-test
BuildRequires:	jboss-transaction-1.0.1-api
BuildRequires:	jbossts
BuildRequires:	jgroups
BuildRequires:	junit
BuildRequires:	log4j
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JMS Integration Tests

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n jms-integration-tests
%patch0 -p1 -b .sav0

pushd thirdparty
mkdir -p apache-log4j/lib
ln -s $(build-classpath log4j) apache-log4j/lib/log4j.jar
mkdir -p oswego-concurrent/lib
ln -s $(build-classpath concurrent) oswego-concurrent/lib/concurrent.jar
mkdir -p javassist/lib
ln -s $(build-classpath javassist) javassist/lib/javassist.jar
mkdir -p jgroups/lib
ln -s $(build-classpath jgroups) jgroups/lib/jgroups.jar
mkdir -p trove/lib
ln -s $(build-classpath gnu-trove) trove/lib/trove.jar
mkdir -p jboss/common-core/lib
ln -s $(build-classpath jboss-common-core) jboss/common-core/lib/jboss-common-core.jar
mkdir -p jboss/common-logging-log4j/lib
ln -s $(build-classpath jboss-common-logging-log4j) jboss/common-logging-log4j/lib/jboss-common-logging-log4j.jar
mkdir -p jboss/common-logging-spi/lib
ln -s $(build-classpath jboss-common-logging-spi) jboss/common-logging-spi/lib/jboss-common-logging-spi.jar
mkdir -p jboss/aop/lib
ln -s $(build-classpath jboss-aop2/jboss-aop) jboss/aop/lib/jboss-aop.jar
mkdir -p jboss/serialization/lib
ln -s $(build-classpath jboss-serialization) jboss/serialization/lib/jboss-serialization.jar
mkdir -p jboss/remoting/lib
ln -s $(build-classpath jboss-remoting) jboss/remoting/lib/jboss-remoting.jar
mkdir -p jboss/jbossts/lib
ln -s $(build-classpath jbossts) jboss/jbossts/lib/jbossts.jar
mkdir -p jboss/test14/lib
ln -s $(build-classpath jboss-test) jboss/test14/lib/jboss-test14.jar
mkdir -p jboss/messaging/lib
ln -s $(build-classpath jboss-messaging) jboss/messaging/lib/jboss-messaging.jar
mkdir -p jboss/microcontainer/lib
ln -s $(build-classpath jboss-microcontainer2/jboss-container) jboss/microcontainer/lib/jboss-microcontainer.jar
mkdir -p junit/lib
ln -s $(build-classpath junit) junit/lib/junit.jar
mkdir -p jboss/jms/lib
ln -s $(build-classpath jboss-jms-1.1-api) jboss/jms/lib/jboss-jms-1.1-api.jar
mkdir -p jboss/transaction/lib
ln -s $(build-classpath jboss-transaction-api) jboss/transaction/lib/jboss-transaction-1.0.1-api.jar
mkdir -p jboss/ejb/lib
ln -s $(build-classpath jboss-ejb-api) jboss/ejb/lib/jboss-ejb-3.0-api.jar
popd
cp -p %{SOURCE1} thirdparty/libraries.ent

%build
export OPT_JAR_LIST=`cat %{_sysconfdir}/ant.d/junit`
export CLASSPATH=$(%{_bindir}/build-classpath jboss5-libs/server jboss-naming/jnpserver)
%{ant} -Dbuild.sysclasspath=first test-jar integration-ejb20-jar

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
cp -p output/lib/integration-mdb20.jar %{buildroot}%{_javadir}/integration-mdb20-%{version}.jar
%add_to_maven_depmap jboss.jms-integration-tests integration-mdb20 %{namedversion} JPP integration-mdb20
cp -p output/lib/integration-mdb20-durable.jar %{buildroot}%{_javadir}/integration-mdb20-durable-%{version}.jar
%add_to_maven_depmap jboss.jms-integration-tests integration-mdb20-durable %{namedversion} JPP integration-mdb20-durable
cp -p output/lib/integration-mdb20-selector.jar %{buildroot}%{_javadir}/integration-mdb20-selector-%{version}.jar
%add_to_maven_depmap jboss.jms-integration-tests integration-mdb20-selector %{namedversion} JPP integration-mdb20-selector
cp -p output/lib/integration-mdb20-userTransaction.jar %{buildroot}%{_javadir}/integration-mdb20-userTransaction-%{version}.jar
%add_to_maven_depmap jboss.jms-integration-tests integration-mdb20-userTransaction %{namedversion} JPP integration-mdb20-userTransaction
cp -p output/lib/integration-mdb20-userTransactionDups.jar %{buildroot}%{_javadir}/integration-mdb20-userTransactionDups-%{version}.jar
%add_to_maven_depmap jboss.jms-integration-tests integration-mdb20-userTransactionDups %{namedversion} JPP integration-mdb20-userTransactionDups
cp -p output/lib/jms-integration-tests.jar %{buildroot}%{_javadir}/jms-integration-tests-%{version}.jar
%add_to_maven_depmap jboss.jms-integration-tests %{name} %{namedversion} JPP %{name}
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
cp -p %{SOURCE3} %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
cp -p %{SOURCE4} %{buildroot}%{_datadir}/maven2/poms/JPP-integration-mdb20.pom
cp -p %{SOURCE5} %{buildroot}%{_datadir}/maven2/poms/JPP-integration-mdb20-durable.pom
cp -p %{SOURCE6} %{buildroot}%{_datadir}/maven2/poms/JPP-integration-mdb20-selector.pom
cp -p %{SOURCE7} %{buildroot}%{_datadir}/maven2/poms/JPP-integration-mdb20-userTransaction.pom
cp -p %{SOURCE8} %{buildroot}%{_datadir}/maven2/poms/JPP-integration-mdb20-userTransactionDups.pom

%if %with repolib
install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
cp -p %{SOURCE2} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
cp -p %{PATCH0} %{buildroot}%{repodirsrc}
cp -p %{SOURCE0} %{buildroot}%{repodirsrc}
cp -p %{SOURCE1} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/jms-integration-tests-%{version}.jar %{buildroot}%{repodirlib}/jms-integration-tests.jar
cp -p %{SOURCE3} %{buildroot}%{repodirlib}/jms-integration-tests.pom
cp -p %{buildroot}%{_javadir}/integration-mdb20-%{version}.jar %{buildroot}%{repodirlib}/integration-mdb20.jar
cp -p %{SOURCE4} %{buildroot}%{repodirlib}/integration-mdb20.pom
cp -p %{buildroot}%{_javadir}/integration-mdb20-durable-%{version}.jar %{buildroot}%{repodirlib}/integration-mdb20-durable.jar
cp -p %{SOURCE5} %{buildroot}%{repodirlib}/integration-mdb20-durable.pom
cp -p %{buildroot}%{_javadir}/integration-mdb20-selector-%{version}.jar %{buildroot}%{repodirlib}/integration-mdb20-selector.jar
cp -p %{SOURCE6} %{buildroot}%{repodirlib}/integration-mdb20-selector.pom
cp -p %{buildroot}%{_javadir}/integration-mdb20-userTransaction-%{version}.jar %{buildroot}%{repodirlib}/integration-mdb20-userTransaction.jar
cp -p %{SOURCE7} %{buildroot}%{repodirlib}/integration-mdb20-userTransaction.pom
cp -p %{buildroot}%{_javadir}/integration-mdb20-userTransactionDups-%{version}.jar %{buildroot}%{repodirlib}/integration-mdb20-userTransactionDups.jar
cp -p %{SOURCE8} %{buildroot}%{repodirlib}/integration-mdb20-userTransactionDups.pom
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/*jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Feb 10 2011 David Walluck <dwalluck@redhat.com> 0:1.0.1-2
- use AS 5 versions of aop and microcontainer
- call ant properly
- move some logic from %%build to %%prep
- add Requires on jpackage-utils for scriptlets
- set Epoch
- fix repolib option
- fix permissions in repolib
- fix install of component-info.xml in repolib
- fix dir ownership in repolib
- add some missing classes to CLASSPATH
- don't run the tests as they require a running server

* Wed Dec 09 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-1
- First build
